using System.Text.Json;
using System.Text.Json.Serialization;

namespace File_Watcher.Models;

public record DeterministicHashCodeConfiguration(int MaxDegreeOfParallelism,
                                                 string[] SidecarExtensions)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, DeterministicHashCodeConfigurationSourceGenerationContext.Default.DeterministicHashCodeConfiguration);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(DeterministicHashCodeConfiguration))]
internal partial class DeterministicHashCodeConfigurationSourceGenerationContext : JsonSerializerContext
{
}