using System.Text.Json;
using System.Text.Json.Serialization;

namespace File_Watcher.Models;

public record SeleniumConfiguration(string DestinationDirectory,
                                    string[] EdgeOptions,
                                    string UniformResourceLocator)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, SeleniumConfigurationSourceGenerationContext.Default.SeleniumConfiguration);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(SeleniumConfiguration))]
internal partial class SeleniumConfigurationSourceGenerationContext : JsonSerializerContext
{
}